;;;
; Generate fact templates.
;;;

(deftemplate placement
 (slot box_one)
 (slot box_two)
 (slot box_three)
 (slot box_four))

(deftemplate ball
 (slot color))

;;;
; Generate rules.
;;;

(defrule placement_constraint1
  ?placement <- (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four))
  (and
	  (placement (box_one ?box_one&Red) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four))
	  (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three&~Blue) (box_four ?box_four)))
	=>
  (retract ?placement))

(defrule placement_constraint2
  ?placement <- (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four))
  (and
	  (placement (box_one ?box_one) (box_two ?box_two&~Yellow) (box_three ?box_three) (box_four ?box_four))
	  (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three&~Green) (box_four ?box_four)))
	=>
  (retract ?placement))

(defrule placement_constraint3
  ?placement <- (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four))
  (or
	  (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four&Green))
	  (placement (box_one ?box_one) (box_two ?box_two&Red) (box_three ?box_three) (box_four ?box_four)))
	=>
  (retract ?placement))

(defrule all_placements
  (ball (color ?box_one))
  (ball (color ?box_two&~?box_one))
  (ball (color ?box_three&~?box_one&~?box_two))
  (ball (color ?box_four&~?box_one&~?box_two&~?box_three))
	=>
  (assert (placement (box_one ?box_one) (box_two ?box_two) (box_three ?box_three) (box_four ?box_four))))

(defrule all_balls
	=>
  (assert (ball (color Red)))
  (assert (ball (color Blue)))
  (assert (ball (color Green)))
  (assert (ball (color Yellow))))	

(reset)
(run)
(facts)    	